`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    01:52:54 03/01/2020 
// Design Name: 
// Module Name:    Frequency 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Frequency(
    clk     ,
    rst_n   ,
    ad_data ,
    Freq    ,
    Period      
    );

    //
    parameter      DATA_W =  32;

    //
    input               clk    ;
    input               rst_n  ;
    input    [7:0]      ad_data;   //AD
    //
    output[DATA_W-1:0]  Freq   ;   //
    output[DATA_W-1:0]  Period ;   //
    //
    wire   [DATA_W-1:0]  Freq   ;
    reg    [DATA_W-1:0]  Period ;
    //
    reg   [25:0]        low_cnt  ;
    reg   [25:0]        high_cnt ;
    reg   [25:0]        low_time ;
    reg   [25:0]        high_time;
    
 //
    reg[1:0] state_c,state_n;
    parameter IDLE=0,S1=1,S2=2;
	 
 //always(
 always@(posedge clk or negedge rst_n)begin
     if(!rst_n)begin
         state_c <= IDLE;
     end
     else begin
         state_c <= state_n;
     end
 end

 //always
 always@(*)begin
     case(state_c)
         IDLE:begin
             if(idl2s1_start)begin
                 state_n = S1;
             end
             else begin
                 state_n = state_c;
             end
         end
         S1:begin
             if(s12s2_start)begin
                 state_n = S2;
             end
             else begin
                 state_n = state_c;
             end
         end
         S2:begin
             if(s22s1_start)begin
                 state_n = S1;
             end
             else begin
                 state_n = state_c;
             end
         end
         default:begin
             state_n = IDLE;
         end
     endcase
 end
 //
 assign idl2s1_start  = state_c==IDLE && wave==1'b1;
 assign s12s2_start = state_c==S1 && wave==1'b0;
 assign s22s1_start = state_c==S2 && wave==1'b1;
 
 assign wave = ad_data[7];//
 
 //always
 always  @(posedge clk or negedge rst_n)begin
     if(!rst_n)begin
         high_cnt <= 26'b0;      //
     end
     else if(state_c==S1)begin
         high_cnt <= high_cnt + 1'b1;  //ߵƽ
     end
     else begin
         high_cnt <= 26'b0;
     end
 end
 always  @(posedge clk or negedge rst_n)begin
     if(!rst_n)begin
         high_time <= 26'b0;      //
     end
     else if(s12s2_start)begin
         high_time <= high_cnt;  //¼ֵΪߵƽʱ䣻
     end
     else begin
         high_time <= high_time;       //high_cnt
     end
 end
 always  @(posedge clk or negedge rst_n)begin
     if(!rst_n)begin
         low_cnt <= 26'b0;      //
     end
     else if(state_c==S2)begin
         low_cnt <= low_cnt + 1'b1;    //
     end
     else begin
         low_cnt <= 26'b0;
     end
 end
 always  @(posedge clk or negedge rst_n)begin
     if(!rst_n)begin
         low_time <= 26'b0;      //
     end
     else if(s22s1_start)begin
         low_time <= low_cnt; 
     end
     else begin
         low_time <= low_time;       //high_cnt
     end
 end

wire [31:0] x,y;
assign y =low_time  + high_time ; //分母
assign x = 50_000_000;//分子

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        Period <= 0;
    end
    else begin
        Period <= y;
    end
end



lpm_div	lpm_div_inst1 (
	.denom ( y ),
	.numer ( x ),
	.quotient ( Freq ),
	.remain ( remain_sig )
	);

endmodule

