`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    02:57:52 03/01/2020 
// Design Name: 
// Module Name:    Meter_Top 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Freq_Volt_Top(
  input        clk     ,
  input        rst_n   ,
  input [7:0]  ad_data ,
  input        key_in  ,
  output       ad_clk  ,
  output[7:0]  seg_sel ,
  output[7:0]  seg_ment 
    );
	 
  wire         key_vld ;
  wire [31:0]  Freq    ;
  wire [31:0]  Period  ;
  wire [31:0]  Volt    ;


  my_pll u_my_pll(
      .inclk0 (clk   ),
      .c0     (ad_clk)
  );

//  assign ad_clk = ~clk ;
  
key_module#(.KEY_W(1)) key_module_inst(
	 .clk(clk),
     .rst_n(rst_n),
	 .key_in(key_in),
	 .key_vld(key_vld)
	 );
	 
Frequency Freq_inst (
    .clk(clk), 
    .rst_n(rst_n), 
    .ad_data(ad_data), 
    .Freq(Freq), 
    .Period(Period)
    );
Voltage Volt_inst (
    .clk(clk), 
    .rst_n(rst_n), 
    .ad_data(ad_data), 
    .Volt(Volt)
    );

seg_disp seg_disp_inst(
    .rst_n(rst_n)       ,
    .clk(clk)           ,
    .disp_en(1'b1)      ,
	.key_vld(key_vld )  ,
    .Freq(Freq)         ,
	.Volt(Volt)         ,
    .din_vld(8'hff)     ,
    .seg_sel(seg_sel)   ,
    .segment(seg_ment)      
             );
	 

endmodule
