`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    02:55:12 03/01/2020 
// Design Name: 
// Module Name:    Voltage 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Voltage(
    clk    ,
    rst_n  ,
    ad_data,
    Volt   
    );

    //
    parameter      TIME_1S =   50_000_000   ;

    //
    input               clk    ;
    input               rst_n  ;
    input    [7:0]      ad_data;
    //
    output  [31:0]      Volt   ;

    //
       
    reg [26:0] rst_cnt;
    wire       add_rst_cnt;
    wire       end_rst_cnt;
    reg        RST;
    reg [15:0] fengzhi_max;
    reg [15:0] fengzhi_min;
	 reg [31:0] Volt;

always@(posedge clk or negedge rst_n)
	begin
		if(!rst_n)
			rst_cnt <= 0;
		else if(add_rst_cnt)begin
			if(end_rst_cnt)
				rst_cnt <= 0;
			else
				rst_cnt <= rst_cnt + 1;
		end
	end
assign add_rst_cnt = 1;
assign end_rst_cnt = add_rst_cnt && rst_cnt==TIME_1S - 1 ;


always@(posedge clk or negedge rst_n)
	begin
		if(!rst_n)
			RST <= 0;
		else if(end_rst_cnt)
			RST <= 0;
		else 
		   RST <= 1;
	end

always @ (posedge clk or negedge rst_n)
begin
	if(!rst_n)
		fengzhi_max <= 16'b0;
	else if(!RST)
		fengzhi_max <= 16'b0;
   else if(ad_data > fengzhi_max)
		fengzhi_max <= ad_data;
   else
        fengzhi_max <= fengzhi_max;
end

always @ (posedge clk or negedge rst_n)
begin
	if(!rst_n)
		fengzhi_min <= 16'd255;
	else if(!RST)
		fengzhi_min <= 16'd255;
	else if(fengzhi_min > ad_data)
		fengzhi_min <= ad_data;
	else
		fengzhi_min <= fengzhi_min;
end

always @ (posedge clk or negedge rst_n)
begin
	if(!rst_n)
		Volt <= 0;
	else begin
	   Volt <= ((fengzhi_max - fengzhi_min ) * 10'd100) >> 8'd8;
	end
end

endmodule


